/*
 * GHITA CRISTIAN-ALIN 331CC
 * PM - 2016
 * PROIECT PM
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>


#define MAX_RAND_SEED 10000
#define MY_DELAY 50
#define MY_SHORT_DELAY 1
#define MATRIX_DIM 8
#define NR_TURE 70	// adica 10 ture

void print_X_on_leds(void) 
{
	uint8_t i;

	//Dau 0V pe toti pinii de iesire => toate ledurile inchise
	for(i = PB0; i <= PB7; i++)
		PORTB &= ~(1 << i);
		PORTA &= ~(1 << i);

	// afiseaza X pe tot displayul
	while (1) {

		for ( i = PB0; i < MATRIX_DIM; i++){
			PORTB |= (1 << i);
			PORTA |= (1 << i);
			PORTA |= (1 << (MATRIX_DIM-1 - i) );
			_delay_ms(MY_SHORT_DELAY);

			PORTB &= ~(1 << i);
			PORTA &= ~(1 << i);
			PORTA &= ~(1 << (MATRIX_DIM-1 - i));
			_delay_ms(MY_SHORT_DELAY);
		}
		// aprind si sting ultima linie
		PORTD |= (1 << PD2);
		PORTA |= (1 << PA7);
		PORTA |= (1 << PA0);
		_delay_ms(MY_SHORT_DELAY);

		PORTD &= ~(1 << PD2);
		PORTA &= ~(1 << PA7);
		PORTA &= ~(1 << PA0);
		_delay_ms(MY_SHORT_DELAY);
	}
}

void print_smiley_face(void) 
{
	uint8_t i;

	//Dau 0V pe toti pinii de iesire, deci initial toate ledurile inchise
	for(i = PB0; i <= PB7; i++)
		PORTB &= ~(1 << i);
		PORTA &= ~(1 << i);

	while (1) {
		// aprind si sting parti din fata
		PORTB |= (1 << PB2);
		PORTA |= (1 << PA2);
		PORTA |= (1 << PA5);
		_delay_ms(MY_SHORT_DELAY);

		PORTB &= ~(1 << PB2);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA5);
		_delay_ms(MY_SHORT_DELAY);

		PORTB |= (1 << PB4);
		PORTA |= (1 << PA1);
		PORTA |= (1 << PA6);
		_delay_ms(MY_SHORT_DELAY);

		PORTB &= ~(1 << PB4);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA6);
		_delay_ms(MY_SHORT_DELAY);

		PORTB |= (1 << PB5);
		PORTA |= (1 << PA2);
		PORTA |= (1 << PA3);
		PORTA |= (1 << PA4);
		PORTA |= (1 << PA5);
		_delay_ms(MY_SHORT_DELAY);

		PORTB &= ~(1 << PB5);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		PORTA &= ~(1 << PA4);
		PORTA &= ~(1 << PA5);
		_delay_ms(MY_SHORT_DELAY);
	}
}

// aprinde urmatoare linie alternand cu player-ul
void progress_obstacle(uint8_t next_line, int8_t curent_col_red, 
						uint8_t column1, uint8_t column2, uint8_t column3) 
{

	// Aprind player 
	PORTD |= (1 << PD2);
	PORTA |= (1 << curent_col_red);
	_delay_ms(MY_DELAY);

	// sting player
	PORTD &= ~(1 << PD2);
	PORTA &= ~(1 << curent_col_red);
	_delay_us(MY_SHORT_DELAY);

	// aprind obstacolele pe linia next_line
	PORTB |= (1 << next_line);
	PORTA |= (1 << column1);
	PORTA |= (1 << column2);
	PORTA |= (1 << column3);
	_delay_ms(MY_DELAY);

	// le sting
	PORTB &= ~(1 << next_line);
	PORTA &= ~(1 << column1);
	PORTA &= ~(1 << column2);
	PORTA &= ~(1 << column3);
	_delay_ms(MY_SHORT_DELAY);
}

// partea activa a jocului
void generate_game(int pseudorandSeed) 
{	
	// obstacolele incep de pe prima linie de pe 3 coloane random
	uint8_t line_start = PB0; 
	srand(pseudorandSeed);
	uint8_t	column1 = rand() % MATRIX_DIM;
	uint8_t column2 = rand() % MATRIX_DIM;
	uint8_t column3 = rand() % MATRIX_DIM;
	uint8_t next_line = line_start;

	// aprind 3 obstacole (leduri) pe prima linie undeva random
	PORTB |= (1 << line_start);
	PORTA |= (1 << column1);
	PORTA |= (1 << column2);
	PORTA |= (1 << column3);
	_delay_ms(MY_DELAY);

	// sting ca sa aprind urmatoarele linii dupa in while
	PORTB &= ~(1 << line_start);
	PORTA &= ~(1 << column1);
	PORTA &= ~(1 << column2);
	PORTA &= ~(1 << column3);
	_delay_ms(MY_DELAY);

	// incep cu player-ul de pe o pozitie random
	int8_t curent_col_red = rand() % MATRIX_DIM;
	uint8_t ture = NR_TURE;
	
	while (ture > 0 ) {
		// incrementez linia si decrementez numarul de ture
		next_line++;
		ture = ture - 1;

		// in caz de coliziune afiseaza X ce semnifica LOSE
		if ( next_line == PB6 && (curent_col_red == column1 || 
			 		curent_col_red == column2 || curent_col_red == column3) )
			print_X_on_leds();

		// in caz ca s a ajuns la ultima linie o iau de la capat pe noi coloane
		if (next_line == PB7) {
			next_line = PB0;
			column1 = rand() % MATRIX_DIM;
			column2 = rand() % MATRIX_DIM;
			column3 = rand() % MATRIX_DIM;		
		}

		// daca e apasat butonul din stanga deplaseaza player-ul in stanga
		if ((PIND &(1 << PD0)) == 0){
			curent_col_red = curent_col_red-1;
			if ( (curent_col_red + 1) == PA0)
				curent_col_red = PA7;
			_delay_ms(MY_DELAY);
		}
		// daca butonul drept este apasat deplaseaza player-ul in dreapta
		if ((PIND &(1 << PD1)) == 0){
			curent_col_red = curent_col_red+1;
			if (curent_col_red - 1  == PA7) // daca e pe ultima coloana trece pe prima
				curent_col_red = PA0;
			_delay_ms(MY_DELAY);
		}
		// daca nu este apasat nici un buton player-ul ramane pe loc
		progress_obstacle(next_line,curent_col_red, column1, column2, column3);
	}

	// dupa un numar predefinit de NR_TURE jocul se incheie cu afisarea unui smiley
	print_smiley_face();
}

int main(void) 
{
	uint8_t i;

	// Setez pinul PD0 si PD1 ca intrare. <- Butoanele
	DDRD &= ~(1 << PD0);
	DDRD &= ~(1 << PD1);
	
	//Activez tensiunea de PULL-UP pe pinii de intrare
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	
	//Setez ca output pinii pentru linie PB 0...6 + 7 separat (PB7 nefunctional)
	// si setez ca output pinii pentru coloane PA 0...7
	for ( i = PB0; i <= PB7; i++) {
		DDRB |= (1 << i);
		DDRA |= (1 << i);
	}
	DDRD |= (1 << PD2); //acest port nu functioneaza pe placuta =>am mutat ultima linie pe PD2

	// Dau 0V pe toti pinii de iesire, deci initial toate ledurile inchise
	for(i = PB0; i <= PB7; i++) {
		PORTB &= ~(1 << i);
		PORTA &= ~(1 << i);
	}
	PORTD &= ~(1 << PD2);

	// folosind un counter discretizat la 1 milisecunda, creez un numar
	// pseudorandom pentru a-l da ca seed lui srand in procesul de start al jocului
	int pseudorandSeed = 0;
	while (pseudorandSeed < MAX_RAND_SEED){
		pseudorandSeed = pseudorandSeed + 1;
		_delay_ms(1);
		// cand apas un buton intrerup counterul si-l trimit ca parametru; 
		if ((PIND &(1 << PD0)) == 0)
			break;
	}

	generate_game(pseudorandSeed); // jocul efectiv
	
	return 0;
}